from __future__ import annotations
from pydantic import Field
from typing import Optional, List, Union
from serializers.json_serializer import ActivityPubModel
from .fields import (
    HeightField,
    HreflangField,
    HrefField,
    MediaTypeField,
    NameMapField,
    NameField, PreviewField,
    RelField, TypeField, WidthField,
    ContextField,
)

class APLink(ActivityPubModel):
    """
    Base class for links

    """
    context: Optional[ContextField] = Field(alias="@context")
    type: Union[TypeField, List[TypeField]]
    name: Optional[NameField] = None
    name_map: Optional[NameMapField] = None
    href: HrefField
    hreflang: HreflangField
    rel: Optional[Union[RelField, List[RelField]]] = None
    height: Optional[HeightField] = None
    width: Optional[WidthField] = None 
    preview: Optional[PreviewField] = None
    media_type: Optional[MediaTypeField]

class APMention(APLink):
    """
    """
    type: TypeField = Field("Mention", const=True)